require 'sketchup.rb'
require 'extensions.rb'


module Baroque
    module VRSketch
        VERSION = "17.0.4"

        HTML_INSTALLATION_BROKEN = (
            '<html><head><style>
                body { font-family: Arial, Helvetica, sans-serif; background-color: "f8f8ff"; }
                form { border-style: outset; border-color: white; border-width: 1;
                       margin-left: 0.5em; margin-right: 0.5em; padding: 0.5em; }
                p.small { font-size: 80%; }
            </style></head><body><br><br><form><br>
            VR Sketch ' + VERSION + ' does not seem to be installed or loaded properly.
            <ol><li>If you just updated, restart SketchUp and try again.<br><br>
            <li>Try reinstalling VR Sketch, possibly with a direct download from<br>
            <a href="https://vrsketch.eu/downloads.html">https://vrsketch.eu/downloads.html</a>.<br><br>
            <li>There are antivirus softwares that are known to cause troubles.<br>Try temporarily disabling your antivirus software.
            </ol>
            <br><p class="small"><!---tag></p>
            </form></body></html>')


        unless file_loaded?(__FILE__)
            if (File.exist?(File.join(File.dirname(__FILE__), "baroquesoftware_vrsketch", "main.rbe")) ||
                File.exist?(File.join(File.dirname(__FILE__), "baroquesoftware_vrsketch", "main.rb")))

                ex = SketchupExtension.new('VR Sketch', 'baroquesoftware_vrsketch/main')
                EXTENSION_ID = ex.id
                #
                ex.description = 'VR Sketch'
                ex.version     = VERSION
                ex.copyright   = 'Baroque Software, 2017-2021'
                ex.creator     = 'Armin Rigo, Maciej Fijalkowski, Duncan Fraser'
                #
                Sketchup.register_extension(ex, true)

                file_loaded(__FILE__)
            else
                # keep the following three lines in sync with the same three lines in main.rb
                dlg = UI::WebDialog.new("VR Sketch installation", true, nil, 750, 400, 200, 200)
                dlg.set_html(HTML_INSTALLATION_BROKEN)
                dlg.show
            end
        end
    end
end
