module Baroque
    module VRSketch
        module Clipboard

            CF_UNICODETEXT = 13

            require 'fiddle'
            require 'fiddle/types'
            require 'fiddle/import'

            module User32
                extend Fiddle::Importer
                dlload 'user32.dll'
                include Fiddle::Win32Types
                extern 'BOOL OpenClipboard(HWND)'
                extern 'BOOL CloseClipboard()'
                extern 'HANDLE GetClipboardData(UINT)'
            end

            module Kernel32
                extend Fiddle::Importer
                dlload 'kernel32'
                include Fiddle::Win32Types
                extern 'void *GlobalLock(HANDLE)'
                extern 'BOOL GlobalUnlock(HANDLE)'
            end

            # see http://www.codeproject.com/KB/clipboard/archerclipboard1.aspx
            def self.paste_latin1()
                data = ""
                if 0 != User32.OpenClipboard(0)
                    hclip = User32.GetClipboardData(CF_UNICODETEXT)
                    if hclip && 0 != hclip
                        ptr = Kernel32.GlobalLock(hclip)
                        # pff pff pff
                        i = 0
                        lst = []
                        while ptr[i] != 0
                            if ptr[i + 1] != 0
                                lst.clear
                                break
                            end
                            lst.push(ptr[i])
                            i += 2
                        end
                        Kernel32.GlobalUnlock(hclip)
                        data = lst.pack("C*")
                    end
                    User32.CloseClipboard()
                end
                return data
            end
        end
    end # module VRSketch
end # module Baroque
