module Baroque
    module VRSketch
        extend self

        CSS = 'body { font-family: Arial, Helvetica, sans-serif; background-color: "f8f8ff"; }
                    p { margin: 0.3em; }
                    p.vskip { margin: 0.5em; }
                    p.small { font-size: 100%; }
                    a.h { color: black; text-decoration:none; }
                    span.slightlysmall { font-size: 90%; }
                    form { border-style: outset; border-color: white; border-width: 1;
                            margin-left: 0.5em; margin-right: 0.5em; padding: 0.4em; }
                    input.text { height: 2em; }
					
					.button {
						background-color: #4CAF50;
						border: none;
						color: white;
						padding: 15px 25px;
						text-align: center;
						font-size: 16px;
						cursor: pointer;
					}
					.button:hover {
						background-color: green;
					}'

        def fill_template(content, h)
            h.each do |k, v|
                # may contain the template several times
                content = content.gsub("{{ " + k.to_s + " }}", v)
            end
            return content
        end

        def get_html(name, template)
            mydir = File.dirname(__FILE__)
            f = open(mydir + "/html/" + name + '.html')
            res = f.read
            template[:style] = CSS
            res = fill_template(res, template)
            f.close
            return res
        end

        # public api

        def show_dialog(name, title, width, height, template: {})
            if @all_dialogs[name] != nil
                @all_dialogs[name].close
                @all_dialogs[name] = nil
            end

            dialog = UI::WebDialog.new(title, true,
                "za.co.VRSketch_" + name, width, height, 200, 250, true)
            
            dialog.set_html(get_html(name, template))

            dialog.show
            @all_dialogs[name] = dialog
            return dialog
        end

    end # module VRSketch
end # module Baroque
